Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 3686)
+++ palm/trunk/SOURCE/Makefile	(revision 3687)
@@ -688,12 +688,4 @@
 	turbulence_closure_mod.f90 \
 	urban_surface_mod.f90 \
-	user_3d_data_averaging.f90 \
-	user_actions.f90 \
-	user_additional_routines.f90 \
-	user_check_data_output.f90 \
-	user_check_data_output_pr.f90 \
-	user_check_parameters.f90 \
-	user_data_output_2d.f90 \
-	user_data_output_3d.f90 \
 	user_data_output_dvrp.f90 \
 	user_data_output_mask.f90 \
@@ -701,7 +693,5 @@
 	user_dvrp_coltab.f90 \
 	user_flight.f90\
-	user_header.f90 \
 	user_init_3d_model.f90 \
-	user_init.f90 \
 	user_init_flight.f90 \
 	user_init_grid.f90 \
@@ -710,14 +700,9 @@
 	user_init_radiation.f90 \
 	user_init_urban_surface.f90 \
-	user_last_actions.f90 \
 	user_lpm_advec.f90 \
 	user_lpm_init.f90 \
 	user_lpm_set_attributes.f90 \
 	user_module.f90 \
-	user_parin.f90 \
-	user_read_restart_data_mod.f90 \
 	user_spectra.f90 \
-	user_statistics.f90 \
-	user_write_restart_data_mod.f90 \
 	vertical_nesting_mod.f90 \
 	virtual_flight_mod.f90 \
@@ -874,6 +859,5 @@
 	netcdf_data_input_mod.o \
 	radiation_model_mod.o \
-	surface_mod.o \
-	user_module.o
+	surface_mod.o
 chem_gasphase_mod.o: \
 	mod_kinds.o \
@@ -1125,10 +1109,8 @@
 init_masks.o: \
 	bulk_cloud_model_mod.o \
-	chemistry_model_mod.o \
-	mod_kinds.o \
-	modules.o \
-	netcdf_interface_mod.o \
-	radiation_model_mod.o \
-	salsa_mod.o
+	mod_kinds.o \
+	module_interface.o \
+	modules.o \
+	netcdf_interface_mod.o
 init_pegrid.o: \
 	mod_kinds.o \
@@ -1330,7 +1312,5 @@
 	synthetic_turbulence_generator_mod.o \
 	urban_surface_mod.o \
-	user_actions.o \
-	user_read_restart_data_mod.o \
-	user_write_restart_data_mod.o \
+	user_module.o \
 	virtual_flight_mod.o \
 	virtual_measurement_mod.o \
@@ -1405,4 +1385,5 @@
 	land_surface_model_mod.o \
 	mod_kinds.o \
+	module_interface.o \
 	modules.o \
 	multi_agent_system_mod.o \
@@ -1421,4 +1402,5 @@
 	model_1d_mod.o \
 	mod_kinds.o \
+	module_interface.o \
 	modules.o \
 	netcdf_interface_mod.o \
@@ -1761,39 +1743,4 @@
 	radiation_model_mod.o \
 	surface_mod.o
-user_3d_data_averaging.o: \
-	mod_kinds.o \
-	modules.o \
-	user_module.o
-user_actions.o: \
-	cpulog_mod.o \
-	mod_kinds.o \
-	modules.o \
-	user_module.o
-user_additional_routines.o: \
-	mod_kinds.o \
-	modules.o \
-	user_module.o
-user_check_data_output.o: \
-	mod_kinds.o \
-	modules.o \
-	user_module.o
-user_check_data_output_pr.o: \
-	mod_kinds.o \
-	modules.o \
-	netcdf_interface_mod.o \
-	user_module.o
-user_check_parameters.o: \
-	mod_kinds.o \
-	modules.o \
-	user_module.o
-user_data_output_2d.o: \
-	mod_kinds.o \
-	modules.o \
-	surface_mod.o \
-	user_module.o
-user_data_output_3d.o: \
-	mod_kinds.o \
-	modules.o \
-	user_module.o
 user_data_output_mask.o: \
 	mod_kinds.o \
@@ -1817,13 +1764,4 @@
 	modules.o \
 	user_module.o
-user_header.o: \
-	mod_kinds.o \
-	modules.o \
-	user_module.o
-user_init.o: \
-	mod_kinds.o \
-	modules.o \
-	netcdf_interface_mod.o \
-	user_module.o
 user_init_3d_model.o: \
 	mod_kinds.o \
@@ -1863,8 +1801,4 @@
 	urban_surface_mod.o \
 	user_module.o
-user_last_actions.o: \
-	mod_kinds.o \
-	modules.o \
-	user_module.o
 user_lpm_advec.o: \
 	mod_kinds.o \
@@ -1880,23 +1814,12 @@
 	user_module.o
 user_module.o: \
-	mod_kinds.o
-user_parin.o: \
-	mod_kinds.o \
-	modules.o \
-	user_module.o
-user_read_restart_data_mod.o: \
-	modules.o \
-	user_module.o
+	mod_kinds.o \
+	modules.o \
+	netcdf_interface_mod.o \
+	surface_mod.o
 user_spectra.o: \
 	mod_kinds.o \
 	modules.o \
 	spectra_mod.o \
-	user_module.o
-user_statistics.o: \
-	mod_kinds.o \
-	modules.o \
-	netcdf_interface_mod.o \
-	user_module.o
-user_write_restart_data_mod.o: \
 	user_module.o
 vertical_nesting_mod.o: \
Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3686)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3687)
@@ -2629,6 +2629,4 @@
     USE pegrid
     USE statistics
-
-    USE user
 
     IMPLICIT NONE
Index: palm/trunk/SOURCE/init_masks.f90
===================================================================
--- palm/trunk/SOURCE/init_masks.f90	(revision 3686)
+++ palm/trunk/SOURCE/init_masks.f90	(revision 3687)
@@ -164,7 +164,4 @@
     USE bulk_cloud_model_mod,                                                  &
         ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
-
-    USE chemistry_model_mod,                                                   &
-        ONLY:  chem_check_data_output
 
     USE control_parameters,                                                    &
@@ -190,4 +187,7 @@
     USE kinds
 
+    USE module_interface,                                                      &
+        ONLY:  module_interface_init_masks
+
     USE netcdf_interface,                                                      &
         ONLY:  domask_unit, netcdf_data_format
@@ -196,11 +196,5 @@
         ONLY:  particle_advection
 
-    USE pegrid  
-    
-    USE radiation_model_mod,                                                   &
-        ONLY:  radiation_check_data_output
-        
-    USE salsa_mod,                                                             &
-        ONLY:  salsa_check_data_output 
+    USE pegrid
 
     IMPLICIT NONE
@@ -494,19 +488,7 @@
 
              CASE DEFAULT
-             
-                CALL user_check_data_output( var, unit )
-                           
-                IF ( salsa )  THEN
-                   CALL salsa_check_data_output( var, unit )
-                ENDIF               
-
-                IF ( unit == 'illegal'  .AND.  air_chemistry                   &
-                     .AND.  (var(1:3) == 'kc_' .OR. var(1:3) == 'em_') )  THEN
-                   CALL chem_check_data_output( var, unit, 0, 0, 0 )
-                ENDIF
-
-                IF ( unit == 'illegal' )  THEN
-                   CALL radiation_check_data_output( var, unit, 0, 0, 0 )
-                ENDIF
+!
+!--             Allocate arrays for other modules
+                CALL module_interface_init_masks( var, unit )
 
                 IF ( unit == 'illegal' )  THEN
Index: palm/trunk/SOURCE/module_interface.f90
===================================================================
--- palm/trunk/SOURCE/module_interface.f90	(revision 3686)
+++ palm/trunk/SOURCE/module_interface.f90	(revision 3687)
@@ -268,14 +268,21 @@
               usm_wrd_local
 
-   USE user_actions_mod,                                                       &
-       ONLY:  user_actions
-
-   USE user_read_restart_data_mod,                                             &
-       ONLY:  user_rrd_global,                                                 &
-              user_rrd_local
-
-   USE user_write_restart_data_mod,                                            &
-       ONLY:  user_wrd_global,                                                 &
-              user_wrd_local
+   USE user,                                                                   &
+       ONLY:  user_parin,                                                      &
+              user_check_parameters,                                           &
+              user_check_data_output_pr,                                       &
+              user_check_data_output,                                          &
+              user_init,                                                       &
+              user_header,                                                     &
+              user_actions,                                                    &
+              user_3d_data_averaging,                                          &
+              user_data_output_2d,                                             &
+              user_data_output_3d,                                             &
+              user_statistics,                                                 &
+              user_rrd_global,                                                 &
+              user_rrd_local,                                                  &
+              user_wrd_global,                                                 &
+              user_wrd_local,                                                  &
+              user_last_actions
 
    USE virtual_measurement_mod,                                                &
@@ -302,4 +309,5 @@
       module_interface_check_data_output_pr,                                   &
       module_interface_check_data_output,                                      &
+      module_interface_init_masks,                                             &
       module_interface_define_netcdf_grid,                                     &
       module_interface_init_arrays,                                            &
@@ -315,5 +323,6 @@
       module_interface_wrd_global,                                             &
       module_interface_rrd_local,                                              &
-      module_interface_wrd_local
+      module_interface_wrd_local,                                              &
+      module_interface_last_actions
 
 
@@ -333,4 +342,8 @@
       MODULE PROCEDURE module_interface_check_data_output
    END INTERFACE module_interface_check_data_output
+
+   INTERFACE module_interface_init_masks
+      MODULE PROCEDURE module_interface_init_masks
+   END INTERFACE module_interface_init_masks
 
    INTERFACE module_interface_define_netcdf_grid
@@ -390,4 +403,8 @@
       MODULE PROCEDURE module_interface_wrd_local
    END INTERFACE module_interface_wrd_local
+
+   INTERFACE module_interface_last_actions
+      MODULE PROCEDURE module_interface_last_actions
+   END INTERFACE module_interface_last_actions
 
 
@@ -499,5 +516,5 @@
    ENDIF
 
-   IF ( unit == 'illegal' )  THEN
+   IF ( unit == 'illegal'  .AND.  radiation )  THEN
       CALL radiation_check_data_output_pr( variable, var_count, unit, dopr_unit )
    ENDIF
@@ -557,5 +574,5 @@
    ENDIF
 
-   IF ( unit == 'illegal' )  THEN
+   IF ( unit == 'illegal'  .AND.  radiation )  THEN
       CALL radiation_check_data_output( variable, unit, i, ilen, k )
    ENDIF
@@ -577,4 +594,38 @@
 
 END SUBROUTINE module_interface_check_data_output
+
+
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Interface for init_masks. ToDo: get rid of these redundant calls!
+!------------------------------------------------------------------------------!
+SUBROUTINE module_interface_init_masks( variable, unit )
+
+
+   CHARACTER (LEN=*), INTENT(IN)    ::  variable !< variable name
+   CHARACTER (LEN=*), INTENT(INOUT) ::  unit     !< physical unit of variable
+
+   IF ( unit == 'illegal'  .AND.  air_chemistry                                &
+        .AND.  (variable(1:3) == 'kc_' .OR. variable(1:3) == 'em_') )  THEN  ! ToDo: remove aditional conditions
+      CALL chem_check_data_output( variable, unit, 0, 0, 0 )
+   ENDIF
+
+   IF ( unit == 'illegal'  .AND.  radiation )  THEN
+      CALL radiation_check_data_output( variable, unit, 0, 0, 0 )
+   ENDIF
+
+   IF ( unit == 'illegal'  .AND.  salsa )  THEN
+      CALL salsa_check_data_output( variable, unit )
+   ENDIF
+
+   IF ( unit == 'illegal' )  THEN
+      unit = ''
+      CALL user_check_data_output( variable, unit )
+   ENDIF
+
+
+END SUBROUTINE module_interface_init_masks
 
 
@@ -650,4 +701,5 @@
    IF ( wind_turbine        )  CALL wtm_init
    IF ( radiation           )  CALL radiation_init
+                               CALL user_init
 
 
@@ -1142,3 +1194,17 @@
 
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Perform module-specific last actions before the program terminates
+!------------------------------------------------------------------------------!
+SUBROUTINE module_interface_last_actions
+
+
+   CALL user_last_actions ! ToDo: make user module switch
+
+
+END SUBROUTINE module_interface_last_actions
+
+
 END MODULE module_interface
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 3686)
+++ palm/trunk/SOURCE/palm.f90	(revision 3687)
@@ -295,4 +295,7 @@
 
     USE kinds
+
+    USE module_interface,                                                      &
+        ONLY:  module_interface_last_actions
 
     USE multi_agent_system_mod,                                                &
@@ -560,16 +563,17 @@
     IF ( myid == 0 )  CALL header
 !
-!-- If required, final  user-defined actions, and
-!-- last actions on the open files and close files. Unit 14 was opened
-!-- in wrd_local but it is closed here, to allow writing on this
-!-- unit in routine user_last_actions.
+!-- Perform module specific last actions
     CALL cpu_log( log_point(4), 'last actions', 'start' )
 
-    IF ( myid == 0 .AND. agents_active ) CALL mas_last_actions
-    CALL user_last_actions
+    IF ( myid == 0 .AND. agents_active ) CALL mas_last_actions ! ToDo: move to module_interface
+
+    CALL module_interface_last_actions
+
+    CALL cpu_log( log_point(4), 'last actions', 'stop' )
+
+!
+!-- Close files
     CALL close_file( 0 )
     CALL close_dvrp
-
-    CALL cpu_log( log_point(4), 'last actions', 'stop' )
 
 !
Index: palm/trunk/SOURCE/user_module.f90
===================================================================
--- palm/trunk/SOURCE/user_module.f90	(revision 3686)
+++ palm/trunk/SOURCE/user_module.f90	(revision 3687)
@@ -70,7 +70,24 @@
 !------------------------------------------------------------------------------!
  MODULE user
- 
+
+
+    USE arrays_3d
+
+    USE control_parameters
+
+    USE cpulog
+
+    USE indices
 
     USE kinds
+
+    USE pegrid
+
+    USE statistics
+
+    USE statistics,                                                            &
+        ONLY:  statistic_regions, region
+
+    USE surface_mod
 
     IMPLICIT NONE
